/*
 * Copyright (C) 2008 - Neil Kettle
 *
 * This file is part of equivset.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _EQUIV_H
#define _EQUIV_H

#include "list.h"

#define CUDD_CONST_ONE  (struct equiv_list *)((~0)-1)
#define CUDD_CONST_ZERO (struct equiv_list *)((~0))

#define CUDD_EQUIV_POSITIVE 0
#define CUDD_EQUIV_NEGATIVE (CUDD_EQUIV_POSITIVE+1)

struct equiv_cache {
  st_table *table;

  int idx;
  int mx_idx;

  struct equiv_list *empty;
  struct equiv_list **page;
};

struct equiv_list *
bddComputeEquivalences (DdManager *, DdNode *);

#endif /* _EQUIV_H */
