/*
 * Copyright (C) 2008 - Neil Kettle
 *
 * This file is part of equivset.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _LIST_H
#define _LIST_H

struct equiv_list_item
{
  int idx;
  int p;
  int n;
};

struct equiv_list
{
  int num_items;
  int max_items;
  struct equiv_list_item items[];
};

#define LIST_EMPTY(a)       ((a)->num_items == 0)
#define LIST_NOT_EMPTY(a)   (!LIST_EMPTY(a))

struct equiv_list *
equiv_list_alloc (int);

#define equiv_list_free(a)  free (a)

void
equiv_list_insert (struct equiv_list *, int, int, int);

struct equiv_list *
equiv_list_init_empty (void);

struct equiv_list *
equiv_list_init_single (int, int, int);

struct equiv_list *
equiv_list_copy_insert (struct equiv_list *, int, int, int);

struct equiv_list *
equiv_list_copy (struct equiv_list *);

void
equiv_list_dump (struct equiv_list *);

#endif /* _LIST_H */
