/*
 * Copyright (C) 2008 - Neil Kettle
 *
 * This file is part of equivset.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _LOOKUP_H
#define _LOOKUP_H

struct lookup_pair
{
  int used;

  struct key_pair {
    int p;
    int n;

    int value;
  } keys[2];
};

struct lookup_list
{
  int num_items;
  int max_items;
  struct lookup_pair items[];
};

#define LOOKUP_EMPTY(a)       ((a)->num_items == 0)
#define LOOKUP_NOT_EMPTY(a)   (!LIST_EMPTY(a))

struct lookup_list *
lookup_list_alloc (int);

#define lookup_list_free(a)   free (a)

struct lookup_pair *
lookup_search_keypair (struct lookup_list *, int, int, int, int);

struct lookup_pair *
lookup_search_value (struct lookup_list *, int);

void
lookup_insert_pair (struct lookup_list *, int, int, int, int);

unsigned int lookup_read_newvar (void);

#endif /* _LOOKUP_H */
